/**********************************************************************/
/*   Include file common to the different terminal emulators.	      */
/**********************************************************************/
# include	<stdio.h>
# include	<fcntl.h>
# include	<string.h>
# include	<signal.h>
# include	<errno.h>
# include	<ctype.h>
# include	<X11/X.h>
# include	<X11/Intrinsic.h>
# include	<X11/StringDefs.h>
# include	<X11/Shell.h>
# include	"ctw.h"
# include	<termio.h>
# include	<unistd.h>
# include	<stdlib.h>
# include	<memory.h>

struct stats {
	long	tot_bytes;
	long	bytes;
	time_t	start_time;
	time_t	time;
	};
extern struct stats  stats, old_stats;

enum emulation {
	EM_NONE = 0,
	EM_ISC = 1,
	EM_SCO = 2
	};
extern enum emulation emulator;

enum menu_items {
	TOGGLE_SCROLLBAR,
	RESET_CHARACTERS,
	DIALOG_BOX,
	MONITOR,
	SET_FONT,
	PASTE
	};

extern char *geometry;
extern char	*widget_name;
extern char	*prog_name;
extern int	pty_fd, tty_fd;

void	setup_signal_handlers PROTO((void));
void	input_callback();
void	appl_callback();
void	pty_input();
void	spawn_child();
void	child_handler();
void	int_handler();
void	resize_callback();
void	set_window_size PROTO((CtwWidget w));
int	steal_switches PROTO((int, char **));
int	do_switches PROTO((int, char **));
void	usage PROTO((void));
void	get_font_size PROTO((CtwWidget, int *, int *));
void	create_icon_pixmap PROTO((void));
void	set_default_attributes PROTO((void));
